sbcast(1)

NAME
sbcast - transmit a file to the nodes allocated to a Slurm job.

SYNOPSIS
sbcast [-CfFjpstvV] SOURCE DEST

DESCRIPTION
sbcast is used to transmit a file to all nodes allocated to the currently active Slurm job. This command should only be executed from within a Slurm batch job or within the shell spawned after a Slurm job's resource allocation. SOURCE is the name of a file on the current node. DEST should be the fully qualified pathname for the file copy to be created on each node. If a fully qualified pathname is not provided, the file will be created in the directory specified in the SbcastParameters parameter in the slurm.conf file (if available) otherwise it will be created in the current working directory from which the sbcast command is invoked. DEST should be on a file system local to that node. Note that parallel file systems may provide better performance than sbcast can provide, although performance will vary by file size, degree of parallelism, and network type.

OPTIONS

-C [library], --compress[=library]
    Compress the file being transmitted. The optional argument specifies the data compression library to be used. Supported values are "lz4" (default), "none" and "zlib". Some compression libraries may be unavailable on some systems. The default compression library (and enabling compression itself) may be set in the slurm.conf file using the SbcastParameter option.

-f, --force
    If the destination file already exists, replace it.

-F number, --fanout=number
    Specify the fanout of messages used for file transfer. Maximum value is currently eight.

-j jobID[.stepID], --jobid=jobID[.stepID]
    Specify the job ID to use with optional step ID. If run inside an allocation this is unneeded as the job ID will read from the environment.

-p, --preserve
    Preserves modification times, access times, and modes from the original file.

-s size, --size=size
    Specify the block size used for file broadcast. The size can have a suffix of k or m for kilobytes or megabytes respectively (defaults to bytes). This size subject to rounding and range limits to maintain good performance. The default value is the file size or 8MB, whichever is smaller. This value may need to be set on systems with very limited memory.

-t seconds, --timeout=seconds
    Specify the message timeout in seconds. The default value is MessageTimeout as reported by "scontrol show config". Setting a higher value may be necessitated by relatively slow I/O performance on the compute node disks.

-v, --verbose
    Provide detailed event logging through program execution.

-V, --version
    Print version information and exit.

PERFORMANCE

Executing sbcast sends a remote procedure call to slurmctld. If enough calls from sbcast or other Slurm client commands that send remote procedure calls to the slurmctld daemon come in at once, it can result in a degradation of performance of the slurmctld daemon, possibly resulting in a denial of service.

Do not run sbcast or other Slurm client commands that send remote procedure calls to slurmctld from loops in shell scripts or other programs. Ensure that programs limit calls to sbcast to the minimum necessary for the information you are trying to gather.

ENVIRONMENT VARIABLES

Some sbcast options may be set via environment variables. These environment variables, along with their corresponding options, are listed below. (Note: Command line options will always override these settings.)

SBCAST_COMPRESS
    -C, --compress

SBCAST_FANOUT
    -F number, --fanout=number

SBCAST_FORCE
    -f, --force

SBCAST_PRESERVE
    -p, --preserve

SBCAST_SIZE
    -s size, --size=size

SBCAST_TIMEOUT
    -t seconds, --timeout=seconds

SLURM_CONF
    The location of the Slurm configuration file.

AUTHORIZATION
When using SlurmDBD, users who have an AdminLevel defined (Operator or Admin) are given the authority to invoke sbcast on other users jobs.

EXAMPLES
Using a batch script, transmit local file my.prog to /tmp/my.proc on the local nodes and then execute it.
$ cat my.job
#!/bin/bash
sbcast my.prog /tmp/my.prog
srun /tmp/my.prog
$ sbatch --nodes=8 my.job
srun: jobid 12345 submitted

COPYING
Copyright (C) 2006-2010 The Regents of the University of California. Produced at Lawrence Livermore National Laboratory (cf, DISCLAIMER).
Copyright (C) 2010-2016 SchedMD LLC.

This file is part of Slurm, a resource management program. For details, see <https://slurm.schedmd.com/>.

Slurm is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

Slurm is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

SEE ALSO
srun(1)